<?php

/**
 * @file
 *  TODO
 */

/**
 * Implements hook_variable_group_info().
 */
function apachesolr_confgen_advanced_settings_variable_group_info() {
  $groups['apachesolr_confgen_advanced_settings'] = array(
    'title' => t('Apache Solr Advanced Settings'),
    'description' => t('Adjustable advanced parameters of the configuration files generated by Apache Solr Config Generator module'),
    'access' => 'administer search',
    'path' => array('admin/config/search/apachesolr/advanced_settings'),
  );

  return $groups;
}

/**
 * Implements hook_variable_info().
 */
function apachesolr_confgen_advanced_settings_variable_info($options) {
  $variables['apachesolr_confgen_advanced_settings_disable_dataDir'] = array(
    'type' => 'boolean',
    'title' => t('Disable Data Dir setting', array(), $options),
    'default' => TRUE,
    'description' => t('Removes the dataDir property from solrconfig.xml. This might be useful for Solr multi core setups, or if you want to use Solr\'s default data dir location. See !link for further instructions.', array('!link' => l(t('Core Administration'), 'http://wiki.apache.org/solr/CoreAdmin')), $options),
    'group' => 'apachesolr_confgen_advanced_settings',
  );

  $variables['apachesolr_confgen_advanced_settings_dataDir'] = array(
    'type' => 'string',
    'title' => t('Data Dir', array(), $options),
    'default' => '${solr.data.dir:./solr/data}',
    'description' => t('Set an explicit path where solr stores the index like /var/sor/data for ubuntu linux', array(), $options),
    'group' => 'apachesolr_confgen_advanced_settings',
  );

  $variables['apachesolr_confgen_advanced_settings_autoCommit_maxTime'] = array(
    'type' => 'number',
    'title' => t('Auto Commit Max Time', array(), $options),
    'default' => 120000,
    'description' => t('Time in ms before documents posted to Solr will be committed to the index. This option is described as "delay" at !link.', array('!link' => l(t('Search Index'), 'admin/config/search/apachesolr/index')), $options),
    'required' => TRUE,
    'group' => 'apachesolr_confgen_advanced_settings',
  );

  return $variables;
}
